// Logitech mouse support from FuhQuake

#include "..\client\client.h"
#include "winquake.h"

typedef void (*MW_DllFunc1)(void);
typedef int (*MW_DllFunc2)(HWND);

MW_DllFunc1 DLL_MW_RemoveHook = NULL;
MW_DllFunc2 DLL_MW_SetHook = NULL;
qboolean MW_Hook_enabled = false;
HINSTANCE mw_hDLL;

void MW_Set_Hook (void)
{
	if (MW_Hook_enabled)
	{
		Com_Printf("MouseWare hook already loaded\n");
		return;
	}

	if (!(mw_hDLL = LoadLibrary("mw_hook.dll")))
	{
		Com_Printf("Couldn't find mw_hook.dll\n");
		return;
	}
	DLL_MW_RemoveHook = (MW_DllFunc1) GetProcAddress(mw_hDLL, "MW_RemoveHook");
	DLL_MW_SetHook = (MW_DllFunc2) GetProcAddress(mw_hDLL, "MW_SetHook");
	if (!DLL_MW_SetHook || !DLL_MW_RemoveHook)
	{
		Com_Printf("Error initializing MouseWare hook\n");
		FreeLibrary(mw_hDLL);
		return;
	}
	if (!DLL_MW_SetHook(cl_hwnd))
	{
		Com_Printf("Couldn't initialize MouseWare hook\n");
		FreeLibrary(mw_hDLL);
		return;
	}
	MW_Hook_enabled = true;
	Com_Printf("MouseWare hook initialized\n");
}

static void MW_Remove_Hook (void)
{
	if (MW_Hook_enabled)
	{
		DLL_MW_RemoveHook();
		FreeLibrary(mw_hDLL);
		MW_Hook_enabled = false;
		Com_Printf("MouseWare hook removed\n");
		return;
	}
	Com_Printf("MouseWare hook not loaded\n");
}

void MW_Shutdown(void)
{
	if (!MW_Hook_enabled)
		return;
	MW_Remove_Hook();
}

int MW_Hook_Message (long buttons)
{
	static long old_buttons = 0;
	int temp;

	//buttons &= 0xFFFF;
	buttons &= 0x00F8;
	temp = (buttons ^ old_buttons);
	old_buttons = buttons;
	return temp;
}


/*
// mw_hook.c by BorisU

#include <windows.h>
#include "..\client\client.h"
#include "winquake.h"

// must correspond to quakedef.h
#define WM_MW_HOOK (WM_USER+1)

#pragma data_seg(".shared")
HANDLE   hInstance   = NULL;
HHOOK   Hook      = NULL;
HWND   MW_Window   = NULL;
HWND   Main_Window = NULL;
#pragma data_seg()
#pragma comment(linker, "/section:.shared,rws")

qboolean WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	hInstance = hinstDLL;
	return true;
}

LRESULT CALLBACK MW_Hook(int nCode, WPARAM wParam, LPARAM lParam)
{
	LPMSG msg = (LPMSG)lParam;

	if (nCode < 0)
	{
		CallNextHookEx(Hook, nCode,
		wParam, lParam);
		return 0;
	}
	if (   (msg->hwnd == MW_Window) &&
		(msg->message == WM_USER + 1221) ){
			PostMessage(Main_Window, WM_MW_HOOK, msg->wParam, msg->lParam);
			msg->message = WM_NULL;
	}
	return CallNextHookEx(Hook, nCode, wParam, lParam);
}

qboolean MW_SetHook (HWND mainwindow)
{
	Main_Window = mainwindow;
	//MW_Window = FindWindow("Logitech E/M Executive", "Logitech E/M Executive");
	MW_Window = FindWindow("Logitech GetMessage Hook", "Logitech GetMessage Hook");
	Hook = SetWindowsHookEx(WH_GETMESSAGE, (HOOKPROC)&MW_Hook, hInstance, 0);

	if (MW_Window && Hook)
		return true;
	return false;
}

void MW_RemoveHook()
{
	UnhookWindowsHookEx(Hook);
}

qboolean MW_Hook_enabled = false;

void MW_Set_Hook (void)
{
	if (MW_Hook_enabled)
	{
		Com_Printf("MouseWare hook already loaded\n");
		return;
	}

	if (!MW_SetHook(cl_hwnd))
	{
		Com_Printf("Couldn't initialize MouseWare hook\n");
		return;
	}
	MW_Hook_enabled = true;
	Com_Printf("MouseWare hook initialized\n");
}

void MW_Remove_Hook (void)
{
	if (!MW_Hook_enabled)
		return;
	MW_RemoveHook();
	MW_Hook_enabled = false;
	Com_Printf("MouseWare hook removed\n");
}

void MW_Shutdown (void)
{
	if (!MW_Hook_enabled)
		return;
	MW_Remove_Hook();
}

int MW_Hook_Message (long buttons)
{
	static long old_buttons = 0;
	int temp;

	buttons &= 0xFFFF;
	temp = (buttons ^ old_buttons);
	//IN_MouseEvent (buttons ^ old_buttons);
	old_buttons = buttons;
	return temp;
}
*/